#! /usr/bin/env python
# -*- coding: utf-8 -*-
####################
# Copyright (c) 2012-2017, SSI. All rights reserved.

import sys
sys.path.insert(1, './')

from twisted.internet import reactor
from pprint import pprint
import soco
from soco import config
from soco.events import event_listener

import logging

def print_event(event):
    try:
        pprint (event.service.service_type)
        pprint (event.variables)
	print
	#if event.service.service_type == "AVTransport":
	#	print (event.variables["current_track_meta_data"].creator)
        print
    except Exception as e:
        print 'There was an error in print_event:', e

def main():
    if len(sys.argv) != 3:
        print ("usage: SOCO.py [ZonePlayerIP] [IndigoServerIP]")
        exit()
    else:
	logging.basicConfig(level=logging.DEBUG)
        device = soco.SoCo(sys.argv[1])
        soco.config.EVENT_LISTENER_IP = sys.argv[2]
 
        print (device.player_name)
        print

        sub = device.renderingControl.subscribe(requested_timeout=600, auto_renew=True)
        sub2 = device.avTransport.subscribe(requested_timeout=600, auto_renew=True)
        sub.callback = print_event
        sub2.callback = print_event

        def before_shutdown():
            sub.unsubscribe()
            sub2.unsubscribe()
            event_listener.stop()

        reactor.addSystemEventTrigger('before', 'shutdown', before_shutdown)

if __name__=='__main__':
    reactor.callWhenRunning(main)
    reactor.run()
